﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;

namespace HeuristicLab.Operators.MPISupport.BinaryTransport {
  [Serializable]
  class ScopeTransfer {
    public string Name { get; set; }
    public string Description { get; set; }
    public List<VariableTransfer> Variables { get; set; }
    public List<ScopeTransfer> SubScopes { get; set; }

    public ScopeTransfer() {
      Variables = new List<VariableTransfer>();
      SubScopes = new List<ScopeTransfer>();
    }

    public static ScopeTransfer Convert(IScope item) {
      ScopeTransfer result = new ScopeTransfer();

      result.Name = item.Name;
      result.Description = item.Description;

      foreach (IVariable variable in item.Variables) {
        result.Variables.Add(VariableTransfer.Convert(variable));
      }

      foreach (IScope subscope in item.SubScopes) {
        result.SubScopes.Add(Convert(subscope));
      }

      return result;
    }

    public static IScope Convert(ScopeTransfer item, IExecutionContext globalScope) {
      IScope result = new Scope();

      result.Name = item.Name;
      result.Description = item.Description;

      foreach (VariableTransfer variable in item.Variables) {
        result.Variables.Add(VariableTransfer.Convert(variable, globalScope));
      }

      foreach (ScopeTransfer subscope in item.SubScopes) {
        result.SubScopes.Add(Convert(subscope, globalScope));
      }

      return result;
    }
  }
}
